DraconisErusRaidRecorder = LibStub("AceAddon-3.0"):NewAddon("Draconis Erus Raid Recorder", "AceConsole-3.0", "AceEvent-3.0", "AceComm-3.0", "AceSerializer-3.0" )
DERR = {}

DERR_VERSION = "20.0607.1"
DERR_VERSION_STAMP = 1591517094
DERR_VERSION_DATA = {}
DERR_USERS = {}
DERR_BIDDERS = {}

table.insert(DERR_VERSION_DATA, DERR_VERSION)
table.insert(DERR_VERSION_DATA, DERR_VERSION_STAMP)

DERR_DEBUG = false
DERR_INBID = false
DERR_INGROUP = false
DERR_WAIT_FOR_RAID = false
DERR_RELOAD = true
DERR_LOADED = false
DERR_OUT_OF_DATE = false
DERR_BID_OFFICER = ""
DERR_GENDER = "female"
DERR_LAST_GUILD_ROSTER = GetServerTime()
DERR_LAST_VERSION_CHECK = GetServerTime()
DERR_PLAYER = ""
DERR_REALM = ""
DERR_GUILD = ""

DERR_BOSS_LIST = {
    "Lucifron", "Magmadar", "Gehennas",
    "Garr", "Baron Geddon", "Shazzrah", "Sulfuron Harbinger", 
    "Golemagg the Incinerator", "Ragnaros",
    "Razorgore the Untamed", "Vaelastrasz the Corrupt", "Broodlord Lashlayer",
    "Firemaw", "Ebonroc", "Flamegor", "Chromaggus", 
    "Nefarian",
    "The Prophet Skeram", "Battleguard Sartura", "Fankriss the Unyielding",
    "Princess Huhuran", "Twin Emperors", "C'Thun", 
    "Bug Family", "Viscidus", "Ouro",
    "Anub'Rekhan", "Grand Widow Faerlina", "Maexxna",
    "Noth the Plaguebringer", "Heigan the Unclean", "Loatheb", 
    "Instructor Razuvious", "Gothik the Harvester", "The Four Horsemen",
    "Patchwerk", "Grobbulus", "Gluth", "Thaddius",
    "Sapphiron", "Kel'Thuzad",
    "Bloodlord Mandokir", "Gahz'ranka", "Hakkar", "High Priest Thekal", "High Priest Venoxis", "High Priestess Arlokk",
    "High Priestess Jeklik", "Jin'do the Hexxer", "High Priestess Mar'li", "Edge of Madness",
    "Ayamiss the Hunter", "Buru the Gorger", "General Rajaxx", "Kurinnaxx", "Moam", "Ossirian the Unscarred",
	"Onyxia",
    "Azuregos", "Lord Kazzak", "Emeriss", "Lethon", "Ysondre", "Taerar"
  }
  
function DraconisErusRaidRecorder:OnInitialize()
	-- Called when the addon is loaded
	if (DEDKPSettings == nil) then DEDKPSettings = {} end
	if (DEDKPSettings["RaidStarted"] == nil) then DEDKPSettings["RaidStarted"] = false end
	if (DEDKPSettings["RaidQueue"] == nil) then DEDKPSettings["RaidQueue"] = {} end
	if (DEDKPSettings["AddonUsers"] == nil) then DEDKPSettings["AddonUsers"] = {} end
	if (DEDKPSettings["RaidID"] == nil) then DEDKPSettings["RaidID"] = 0 end
	if (DEDKPSettings["BossKills"] == nil) then DEDKPSettings["BossKills"] = {} end
	if (DEDKPSettings["LootRaid"] == nil) then DEDKPSettings["LootRaid"] = false end

	if (DEDKPWindows == nil) then DEDKPWindows = {} end

	-- Print a message to the chat frame
	DraconisErusRaidRecorder:Print("Initialized.")

	DERR_PLAYER = UnitName("player")
	DERR_PLAYER = DraconisErus_FixName(DERR_PLAYER)
	DERR_GENDER = UnitSex("player")

	dedkp_class_list = {}
	dedkp_class_info = {}
	for i = 1, 12 do
		local classInfo = C_CreatureInfo.GetClassInfo(i)
		if classInfo then
			local red, green, blue, hex = GetClassColor(classInfo.classFile)
			if classInfo.classFile == "SHAMAN" then
				red = 0.0
				green = 0.44
				blue = 0.87
				hex = "ff0070de"
			end
			dedkp_class_info[classInfo.classFile] = { id = i, localName = classInfo.className, r = red, g = green, b = blue, h = hex }
			table.insert(dedkp_class_list,classInfo.className)
			table.sort(dedkp_class_list)
		end
	end
end

function DraconisErusRaidRecorder:OnEnable()

	C_Timer.After(0,function()
		C_Timer.After(5,function()
			self:RegisterChatCommand("dedkp", DraconisErus_Command)
			if IsInGuild() then
				DraconisErus_Init()
			end
			self:RegisterEvent("GUILD_ROSTER_UPDATE")
		end)
	end)

end

function DraconisErus_Command()
	if IsInGuild() then
		if DERR_LOADED then
			DraconisErus_Show()
		else
			DraconisErusRaidRecorder:Print("Raid Recorder not loaded.  Please try again.")
		end
	else
		DraconisErusRaidRecorder:Print("Raid Recorder only works in a guild.")
	end
end

function DraconisErus_Init()
	DraconisErusRaidRecorder:RegisterChatCommand("dedkpsaveguild", DraconisErus_Guild_Save)

	DraconisErusRaidRecorder:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	DraconisErusRaidRecorder:RegisterEvent("CHAT_MSG_MONSTER_YELL")
	DraconisErusRaidRecorder:RegisterEvent("CHAT_MSG_SYSTEM")
	DraconisErusRaidRecorder:RegisterEvent("CHAT_MSG_LOOT")
	DraconisErusRaidRecorder:RegisterEvent("GROUP_ROSTER_UPDATE")
	DraconisErusRaidRecorder:RegisterEvent("LOOT_OPENED")
	DraconisErusRaidRecorder:RegisterEvent("PLAYER_LEVEL_UP")

	hooksecurefunc("ContainerFrameItemButton_OnModifiedClick", DraconisErus_ContainerClick)
	GameTooltip:HookScript("OnTooltipSetItem", DraconisErus_Tooltip)
	ItemRefTooltip:HookScript("OnTooltipSetItem", DraconisErus_Tooltip)
	DraconisErusRaidRecorder:RegisterComm("DERRADDON", "Comm_Addon")
	DraconisErusRaidRecorder:RegisterComm("DERRSTARTRAID", "Comm_Start_Raid")
	DraconisErusRaidRecorder:RegisterComm("DERRENDRAID", "Comm_End_Raid")
	DraconisErusRaidRecorder:RegisterComm("DERRSTARTLOOT", "Comm_Start_Loot")
	DraconisErusRaidRecorder:RegisterComm("DERRENDLOOT", "Comm_End_Loot")
	DraconisErusRaidRecorder:RegisterComm("DERRBID", "Comm_Bid")
	DraconisErusRaidRecorder:RegisterComm("DERRBIDDONE", "Comm_Bid_Done")
	DraconisErusRaidRecorder:RegisterComm("DERRBIDCONFIRM", "Comm_Bid_Confirm")
	DraconisErusRaidRecorder:RegisterComm("DERRBOSSKILL", "Comm_Boss_Kill")
	DraconisErusRaidRecorder:RegisterComm("DERRAWARDLOOT","Comm_Award_Loot")
	DraconisErusRaidRecorder:RegisterComm("DERRADDSTANDBY", "Comm_Add_Standby")
	DraconisErusRaidRecorder:RegisterComm("DERRREMSTANDBY", "Comm_Remove_Standby")
	DraconisErusRaidRecorder:RegisterComm("DERRSENDRAID", "Comm_Send_Raid")
	DraconisErusRaidRecorder:RegisterComm("DERRRECEIVERAID", "Comm_Receive_Raid")
	DraconisErusRaidRecorder:RegisterComm("DERRVERSION", "Comm_Version")
	DraconisErusRaidRecorder:RegisterComm("DERRPING","Comm_Ping")
	DraconisErusRaidRecorder:RegisterComm("DERRPONG","Comm_Pong")
	DraconisErusRaidRecorder:RegisterComm("DERRLEVEL", "Comm_Level")
	DraconisErusRaidRecorder:RegisterComm("DERRSENDDKP", "Comm_SendPoints")
	DraconisErusRaidRecorder:RegisterComm("DERRGETDKP", "Comm_ReceivePoints")

	DERR_LAST_VERSION_CHECK = GetServerTime()
	DraconisErus_Comm_Send("DERRVERSION",DERR_VERSION_DATA,"GUILD")
	DERR_GUILD = GetGuildInfo("player")
	DERR_REALM = GetRealmName()

	if DEDKPRaids == nil then DEDKPRaids = {} end
	if DEDKPRaids[DERR_REALM] == nil then DEDKPRaids[DERR_REALM] = {} end
	if DEDKPRaids[DERR_REALM][DERR_GUILD] == nil then DEDKPRaids[DERR_REALM][DERR_GUILD] = {} end

	if DEDKPGuilds == nil then DEDKPGuilds = {} end
	if DEDKPGuilds[DERR_REALM] == nil then DEDKPGuilds[DERR_REALM] = {} end
	if DEDKPGuilds[DERR_REALM][DERR_GUILD] == nil then DEDKPGuilds[DERR_REALM][DERR_GUILD] = {} end

	if DEDKPLoot == nil then DEDKPLoot = {} end
	if DEDKPLoot[DERR_REALM] == nil then DEDKPLoot[DERR_REALM] = {} end
	if DEDKPLoot[DERR_REALM][DERR_GUILD] == nil then DEDKPLoot[DERR_REALM][DERR_GUILD] = {} end

	if DEDKPPoints == nil then DEDKPPoints = {} end
	if DEDKPPoints[DERR_REALM] == nil then DEDKPPoints[DERR_REALM] = {} end
	if DEDKPPoints[DERR_REALM][DERR_GUILD] == nil then DEDKPPoints[DERR_REALM][DERR_GUILD] = {} end

	DraconisErus_Events_Clean()

	if IsInRaid() then
		DraconisErusRaidRecorder:GROUP_ROSTER_UPDATE()
	else
		DraconisErus_NoRaid()
	end
	DERR_LOADED = true
	DraconisErusRaidRecorder:Print("Loaded ("..DERR_VERSION..")")

	C_Timer.After(0,function()
		C_Timer.After(10,function()
			DraconisErus_Guild_RequestPoints()
		end)
	end)
end

function DraconisErus_Unload()
	if DERR_LOADED then
		DraconisErusRaidRecorder:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		DraconisErusRaidRecorder:UnregisterEvent("CHAT_MSG_MONSTER_YELL")
		DraconisErusRaidRecorder:UnregisterEvent("CHAT_MSG_SYSTEM")
		DraconisErusRaidRecorder:UnregisterEvent("CHAT_MSG_LOOT")
		DraconisErusRaidRecorder:UnregisterEvent("GROUP_ROSTER_UPDATE")
		DraconisErusRaidRecorder:UnregisterEvent("LOOT_OPENED")
		DraconisErusRaidRecorder:UnregisterEvent("PLAYER_LEVEL_UP")

		DraconisErusRaidRecorder:UnregisterComm("DERRADDON")
		DraconisErusRaidRecorder:UnregisterComm("DERRSTARTRAID")
		DraconisErusRaidRecorder:UnregisterComm("DERRENDRAID")
		DraconisErusRaidRecorder:UnregisterComm("DERRSTARTLOOT")
		DraconisErusRaidRecorder:UnregisterComm("DERRENDLOOT")
		DraconisErusRaidRecorder:UnregisterComm("DERRBID")
		DraconisErusRaidRecorder:UnregisterComm("DERRBIDDONE")
		DraconisErusRaidRecorder:UnregisterComm("DERRBIDCONFIRM")
		DraconisErusRaidRecorder:UnregisterComm("DERRBOSSKILL")
		DraconisErusRaidRecorder:UnregisterComm("DERRAWARDLOOT")
		DraconisErusRaidRecorder:UnregisterComm("DERRADDSTANDBY")
		DraconisErusRaidRecorder:UnregisterComm("DERRREMSTANDBY")
		DraconisErusRaidRecorder:UnregisterComm("DERRSENDRAID")
		DraconisErusRaidRecorder:UnregisterComm("DERRRECEIVERAID")
		DraconisErusRaidRecorder:UnregisterComm("DERRVERSION")
		DraconisErusRaidRecorder:UnregisterComm("DERRPING")
		DraconisErusRaidRecorder:UnregisterComm("DERRPONG")
		DraconisErusRaidRecorder:UnregisterComm("DERRLEVEL")
		DraconisErusRaidRecorder:UnregisterComm("DERRSENDDKP")
		DraconisErusRaidRecorder:UnregisterComm("DERRGETDKP")
		DERR_LOADED = false
	end
end

function DraconisErusRaidRecorder:OnDisable()
	-- Called when the addon is disabled

	self:UnregisterEvent("GUILD_ROSTER_UPDATE")

	DraconisErus_Unload()

end

function DraconisErus_Show()
	if DERR.MainWindow == nil then
		DEDKP_MainWindow_Show()
	end
end

function DraconisErus_ContainerClick(self, button)
	if DERR_INBID then return end
	if not DraconisErus_PlayerAuth(1,1,1) then return end
	if (button == "RightButton" and IsControlKeyDown() and IsAltKeyDown()) then
		local slot, bag = GetMouseFocus():GetID(), GetMouseFocus():GetParent():GetID()
		local texture, count, locked, quality, readable, lootable, link = GetContainerItemInfo(bag, slot)
		if (link ~= nil) then
			if UnitIsGroupAssistant("player") or UnitIsGroupLeader("player") then
				DEDKP_BidManager_SetItem(link)
			else
				DraconisErusRaidRecorder:Print("|cFFFF0000You must have raid assist to handle bidding.|r")
			end
		end
	end
end

function DraconisErus_NoRaid()
	DEDKPSettings["RaidStarted"] = false
	DEDKPSettings["RaidQueue"] = {}
	DEDKPSettings["AddonUsers"] = {}
	DEDKPSettings["RaidID"] = 0
	DEDKPSettings["BossKills"] = {}
	DEDKPSettings["LootRaid"] = false
end

